/** @file dump_fastq_main_cmdline.hpp
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.4
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef DUMP_FASTQ_MAIN_CMDLINE_H
#define DUMP_FASTQ_MAIN_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef DUMP_FASTQ_MAIN_CMDLINE_PACKAGE
/** @brief the program name (used for printing errors) */
#define DUMP_FASTQ_MAIN_CMDLINE_PACKAGE "jellyfish qdump"
#endif

#ifndef DUMP_FASTQ_MAIN_CMDLINE_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define DUMP_FASTQ_MAIN_CMDLINE_PACKAGE_NAME "jellyfish qdump"
#endif

#ifndef DUMP_FASTQ_MAIN_CMDLINE_VERSION
/** @brief the program version */
#define DUMP_FASTQ_MAIN_CMDLINE_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct dump_fastq_main_args
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int column_flag;	/**< @brief Column format (default=off).  */
  const char *column_help; /**< @brief Column format help description.  */
  int tab_flag;	/**< @brief Tab separator (default=off).  */
  const char *tab_help; /**< @brief Tab separator help description.  */
  float lower_count_arg;	/**< @brief Don't output k-mer with count < lower-count.  */
  char * lower_count_orig;	/**< @brief Don't output k-mer with count < lower-count original value given at command line.  */
  const char *lower_count_help; /**< @brief Don't output k-mer with count < lower-count help description.  */
  float upper_count_arg;	/**< @brief Don't output k-mer with count > upper-count.  */
  char * upper_count_orig;	/**< @brief Don't output k-mer with count > upper-count original value given at command line.  */
  const char *upper_count_help; /**< @brief Don't output k-mer with count > upper-count help description.  */
  int verbose_flag;	/**< @brief Be verbose (default=off).  */
  const char *verbose_help; /**< @brief Be verbose help description.  */
  char * output_arg;	/**< @brief Output file (default='/dev/fd/1').  */
  char * output_orig;	/**< @brief Output file original value given at command line.  */
  const char *output_help; /**< @brief Output file help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int column_given ;	/**< @brief Whether column was given.  */
  unsigned int tab_given ;	/**< @brief Whether tab was given.  */
  unsigned int lower_count_given ;	/**< @brief Whether lower-count was given.  */
  unsigned int upper_count_given ;	/**< @brief Whether upper-count was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct dump_fastq_main_cmdline_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure dump_fastq_main_args (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure dump_fastq_main_args (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *dump_fastq_main_args_purpose;
/** @brief the usage string of the program */
extern const char *dump_fastq_main_args_usage;
/** @brief all the lines making the help output */
extern const char *dump_fastq_main_args_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int dump_fastq_main_cmdline (int argc, char **argv,
  struct dump_fastq_main_args *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use dump_fastq_main_cmdline_ext() instead
 */
int dump_fastq_main_cmdline2 (int argc, char **argv,
  struct dump_fastq_main_args *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int dump_fastq_main_cmdline_ext (int argc, char **argv,
  struct dump_fastq_main_args *args_info,
  struct dump_fastq_main_cmdline_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int dump_fastq_main_cmdline_dump(FILE *outfile,
  struct dump_fastq_main_args *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int dump_fastq_main_cmdline_file_save(const char *filename,
  struct dump_fastq_main_args *args_info);

/**
 * Print the help
 */
void dump_fastq_main_cmdline_print_help(void);
/**
 * Print the version
 */
void dump_fastq_main_cmdline_print_version(void);

/**
 * Initializes all the fields a dump_fastq_main_cmdline_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void dump_fastq_main_cmdline_params_init(struct dump_fastq_main_cmdline_params *params);

/**
 * Allocates dynamically a dump_fastq_main_cmdline_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized dump_fastq_main_cmdline_params structure
 */
struct dump_fastq_main_cmdline_params *dump_fastq_main_cmdline_params_create(void);

/**
 * Initializes the passed dump_fastq_main_args structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void dump_fastq_main_cmdline_init (struct dump_fastq_main_args *args_info);
/**
 * Deallocates the string fields of the dump_fastq_main_args structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void dump_fastq_main_cmdline_free (struct dump_fastq_main_args *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int dump_fastq_main_cmdline_required (struct dump_fastq_main_args *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* DUMP_FASTQ_MAIN_CMDLINE_H */
